﻿Imports System.Management

Public Class RegistryWatcher

    Public Watcher As ManagementEventWatcher

    Sub New()
    End Sub

    Public Sub New(ByVal hive As String, ByVal keyPath As String, ByVal Optional valueName As String = "")
        Try
            Dim query As New WqlEventQuery(
                $"SELECT * FROM RegistryValueChangeEvent WHERE Hive = '{hive}' AND KeyPath = '{keyPath}'" &
                If(valueName <> "", $" AND ValueName='{valueName}'", valueName))
            Watcher = New ManagementEventWatcher(query)
            AddHandler Watcher.EventArrived, AddressOf Watcher_EventArrived
            AddHandler Watcher.Stopped, AddressOf Watcher_Stopped
        Catch managementException As ManagementException
            Console.WriteLine($"Error: {managementException.Message}")
        End Try
    End Sub

    Public Sub Start()
        Try
            Watcher.Start()
            Console.WriteLine("Waiting for an event...")
        Catch managementException As ManagementException
            Console.WriteLine($"Error: {managementException.Message}")
        End Try
    End Sub

    Public Sub [Stop]()
        Watcher.Stop()
    End Sub

    Private Sub Watcher_EventArrived(sender As Object, e As EventArrivedEventArgs)
        Console.WriteLine("Received an event.")
    End Sub

    Private Sub Watcher_Stopped(sender As Object, e As EventArgs)
        Console.WriteLine("Stopped.")
    End Sub

End Class